#include <SoftwareSerial.h>
#include "Bluetooth.h"

Bluetooth *blue = new Bluetooth(2, 3); //RX PIN BT - PIN 3 ARDUINO, TX PIN BT - PIN 2 ARDUINO

int pos = 0;

void setup(){
        
  	Serial.begin(9600);

	blue->setName("INFINITY"); //Set the bluetooth name
	blue->setPIN(1234); //set the PIN NUMBER
	blue->setMessageEnd('#'); //use the # as the end of the message
	blue->setupBluetooth();  //applay the changes to the bluetooth module

	//motor->setSpeed(180); //set the motor speed, value from 0 to 255
}

void loop(){
  
// STEP 0: FASE DI LETTURA VIA BT (bluetooth) dell'informazione sui metri cubi (m3) da inserire

	String msg = blue->read();    // read messages (arriving in queue)
	if(msg.length() > 1){         // check the length of the message :(if message exist...)
                Serial.println(msg);  // print on SerialMonitor (PC), for testing...
		readMsg(msg);         // analyze the message!
}
	delay(20); //wait 20 ms : (loop() executed every 20 ms)
// FINE STEP 0
}

/* FUNZIONE PER LEGGERE L'INFORMAZIONE INVIATA VIA BT DAL DISPOSITIVO ANDROID (precedentemente inviatagli dal beacon)
**
*/
void readMsg(String msg){
  	String SB, TB; //second byte and third byte, the parameters in the message : (3@SB@TB#)
	int iSB, iTB;
	int i;
        
        switch (msg.charAt(0)) { //we read the first number to check the action
	    case '1': //not used in this tutorial. Set an Android PIN value
	      break;
	    case '2': //not used in this tutorial. Get an Android PIN value
	      break;
	    case '3': //call a method
                Serial.println(msg.charAt(0)); // print 1st parameter on SerialMonitor (PC), for testing...
                
	    	for(i = 2; i < msg.length(); i++){//we start at pos 2, because the msg[0] is 3 and msg[1] is '@'
	    		if(msg.charAt(i) == '#') //end of the message
	    			break;
	    		if(msg.charAt(i) == '@') //read the next parameter
	    			for(int k = i+1; k < msg.length(); k++){
	    				if(msg.charAt(k) == '#')
	    					break;
	    				TB += msg.charAt(k);
	    			}
	    		SB += msg.charAt(i);
	    	}
	    	iSB = SB.toInt();
	    	iTB = TB.toInt();
                Serial.println(iSB);  // print 2nd parameter on SerialMonitor (PC), for testing...
                Serial.println(iTB);  // print 3rd parameter on SerialMonitor (PC), for testing...
                callMethod(iSB, iTB); // we call the method sending the second and third value received : To understand that action to make arduino (at motors, at ultrasonic sensor, etc.)
            break;
	}
  }

/* UTILE ALLA FASE DI CONTROLLO (SULLA CORRETTA PRESSIONE DEI VARI PULSANTI)
** OPZIONE 1: la fase di controllo Ã¨ passata all'app Android (elaborazione di immagini)
** OPZIONE 2: la fase di controllo Ã¨ passata all'app Android (riconoscimanto beep): in questo caso l'algoritmo dovrebbe partire in corrispondenza dello STEP 1
** OPZIONE 3: la fase di controllo avviene internamente a questo sketch, tramite sensore acustico (riconoscimanto beep): in questo caso l'algoritmo dovrebbe partire in corrispondenza dello STEP 1
*/
void returnValue(int id, int value){
	char Id[5], Val[5], msg[1024];
	sprintf(Id, "%d", id);
	sprintf(Val, "%d", value);
	strcpy(msg, Id);
	strcat(msg, "@");
	strcat(msg, Val);
	strcat(msg, "#");

	blue->send(msg); //send the message in the format "ID@VALUE#"
}

/* METODO DA UTILIZZARE IN BASE ALLA STRINGA RICEVUTA (FORMATO STRINGA: 3@cod@arg1)
** case 3@1@    STEP1 : SETTING MODE
** case 3@2@m3  STEP2 : UP (INSERT M3)
** case 3@3@m3  STEP3 : DOWN (REMOVE M3)
** case 3@4@    STEP4 : STARTING MODE
*/
void callMethod(int cod, int arg1){
  switch (cod) {
    case 1:
     Serial.println('1'); // print 2nd parameter on SerialMonitor (PC), for testing...
     break;
    case 2:
    Serial.println('2'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 3:
    Serial.println('3'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 4:
    Serial.println('4'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 5:
    Serial.println('5'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 6:
    Serial.println('6'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 7:
    Serial.println('7'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 8:
    Serial.println('8'); // print 2nd parameter on SerialMonitor (PC), for testing...
      break;
    case 9:
    Serial.println('9');  // print 2nd parameter on SerialMonitor (PC), for testing...
    Serial.println(arg1); // print 3rd parameter on SerialMonitor (PC), for testing...
    delay(arg1);   //invio/aggiunta ritardo...
      break;
    case 99:
    Serial.println("99"); // print 2nd parameter on SerialMonitor (PC), for testing...
    returnValue(arg1, 99);  //utile per capire l'istante in cui il delay() si è concluso: conviene dunque inviare tale comando subito dopo l'invio di 3@9@delayvalue#
      break;
  }
}

void setProcess() {

  //pushButton(servoSet);
  Serial.println("pushButton(servoSet);");

}


